SELECT t.tablename, 
c.reltuples::bigint AS num_rows,
ps.indexrelname AS index_name,
ps.idx_scan AS num_scans,
ps.idx_tup_read AS t_read,
ps.idx_tup_fetch AS t_fetched
FROM pg_tables t
LEFT JOIN pg_class c ON t.tablename = c.relname
LEFT JOIN pg_index i ON c.oid = i.indrelid
LEFT JOIN pg_stat_all_indexes ps ON i.indexrelid = ps.indexrelid
WHERE t.schemaname NOT IN ('pg_catalog', 'information_schema')
ORDER BY 1, 2;
