CREATE OR REPLACE FUNCTION f_sales()
RETURNS TEXT AS $$
DECLARE
  text_output TEXT = E'\n';
  v_orderdate orders.orderdate%TYPE;
  v_total orders.totalamount%TYPE;
  v_tax orders.tax%TYPE;
  c_sales CURSOR FOR
    SELECT orderdate, totalamount, tax FROM orders;
BEGIN
  OPEN c_sales;
  LOOP
    FETCH c_sales INTO v_orderdate, v_total, v_tax;
    EXIT WHEN NOT FOUND;
    IF v_total > 1000 THEN
      text_output := text_output || v_orderdate || ' - ' || v_total || ' - ' || v_tax || E'\n';
    END IF;
  END LOOP;
  CLOSE c_sales;
  RETURN text_output;
END;
$$ LANGUAGE plpgsql;

SELECT f_sales();
