CREATE TABLE audit_orders(
> op       CHAR(1),
> datum    TIMESTAMP,
> userid   TEXT,
> amount   NUMERIC(8,2));

CREATE FUNCTION  trig_orders() RETURNS TRIGGER
AS $$
BEGIN
  IF (TG_OP = 'INSERT') THEN
    INSERT INTO audit_orders SELECT 'I',now(),user,NEW.totalamount;
    RETURN NEW;
  ELSIF (TG_OP = 'UPDATE') THEN
    INSERT INTO audit_orders SELECT 'U',now(),user,NEW.totalamount;
  ELSIF (TG_OP = 'DELETE') THEN
    INSERT INTO audit_orders SELECT 'U',now(),user,OLD.totalamount;
  END IF;
RETURN NULL;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER trig_orders
AFTER INSERT OR UPDATE OR DELETE ON orders
FOR EACH ROW EXECUTE PROCEDURE trig_orders();

UPDATE orders
SET totalamount = totalamount + totalamount * 0.1
WHERE totalamount > 500;

SELECT * FROM audit_orders;
