#include <stdio.h>
#include “libpq-fe.h”
#include “libpq/libpq-fs.h”
int main(int argc, char **argv) {
  char *filename;
  PGconn *conn;
  PGresult *result;
  Oid lo_id;
  if ( argc != 2) {
    printf(“Usage: %s filename.\n”, argv[0]);
    exit(1);
  }
  filename = argv[1];
  conn = PQconnectdb(“”);
  if ( PQstatus(conn) == CONNECTION_OK ) {
    printf(“Importing file %s as Large Object to database...\n”, filename);
    result = PQexec(conn, “BEGIN”);
    PQclear(result);
    lo_id = lo_import(conn, filename);
    printf(“Object ID is: %d\n”, lo_id);
    result = PQexec(conn, “END”);
    PQfinish(conn);
  } else {
    printf(“%s\n”,“Connection to database could not be established.”);
    printf(“%s\n”, PQerrorMessage(conn));
  }
}
