#include <stdio.h>
#include “libpq-fe.h”
#ifdef TRACE
#define TRACEFILE “trace.log”
#endif
int main(int argc, char **argv) {
#ifdef TRACE
  FILE *trc;
#endif  
  PGresult *res;
  const char *conninfo;
  conninfo = “host=localhost port=5432 dbname=hanser user=postgres 
password=postgres connect_timeout=5”;
  printf(“SQL-Anweisung: %s\n”,argv[1]);  
  PGconn *myconn = PQconnectdb(conninfo);
  if (PQstatus(myconn) == CONNECTION_OK) {
    printf(“Verbindung hergestellt\n”);
#ifdef TRACE
  trc = fopen(TRACEFILE, “w”);
  PQtrace(myconn, trc);
#endif  
  } else {
    printf(“Verbindung fehlgeschlagen\n”);
    printf(“Fehler: %s\n”, PQerrorMessage(myconn));
  }
  res = PQexec(myconn, argv[1]);
  switch(PQresultStatus(res)) {
  case PGRES_COMMAND_OK:
    printf(“Anweisung erfolgreich ausgefuehrt\n”);
    break;
  case PGRES_TUPLES_OK:
    printf(“Anweisung mit Resultset\n”);
    break;
  case PGRES_EMPTY_QUERY:
    printf(“Leere Anweisung\n”);
    break;
  case PGRES_FATAL_ERROR:
    printf(“Fehler\n”);
    break;
  }
  PQfinish(myconn);
#ifdef TRACE
  fclose(trc);
#endif  
  return EXIT_SUCCESS;
}
