import psycopg2
from psycopg2 import pool
try:
  simple_pool = psycopg2.pool.SimpleConnectionPool(5, 20, user="postgres", password="postgres", host="localhost", port="5432", database="hanser")
  if (simple_pool):                                                       
    print("Simple Connection Pool erfolgreich erstellt") 
    conn = simple_pool.getconn()                                           
    if (conn):
      print("Verbindung vom Connection Pool erhalten")
      cursor = conn.cursor()
      cursor.execute("SELECT * FROM products LIMIT 1")
      rows = cursor.fetchall()
      print("Anzeige der gelesenen Sätze:")
      for row in rows:
        print(row)
      cursor.close()
      simple_pool.putconn(conn)                                           
      print("Verbindung freigegeben")
except (Exception, psycopg2.DatabaseError) as error:
  print("Verbindungsfehler zu PostgreSQL: ", error)
finally:
  if simple_pool:
    simple_pool.closeall                                                   
    print("Simple Connection Pool geschlossen")
