CREATE OR REPLACE FUNCTION public.create_load(tablename character varying, csvfile character varying)
RETURNS character varying
LANGUAGE plpython3u
AS $$
import csv
import datetime
import locale
def isfloat(str):
  if str.isdigit and str.find(".")!=-1:
    return True
  else:
    return False
def isdatetime(str):
  try:
    datetime.datetime.strptime(str, '%d-%b-%y %H:%M:%S')
    return True
  except ValueError:
    return False
def get_coltype(str):
  if isfloat(str):
    return "NUMERIC(10,4)"
  else:
    if str.isdigit():
      return "INTEGER"
    else:
      if isdatetime(str):
        return "TIMESTAMP"
      else:
        return "VARCHAR(200)"
  return "N/A"
def create_table(header, first_line):
  create_stmt = "CREATE TABLE " + tablename + "("
  i = 0
  for col_name in header:
    create_stmt += col_name + " " + get_coltype(first_line[i])
    if i < len(first_line)-1:
      create_stmt = create_stmt + ","
    create_stmt = create_stmt + "\n"
    i = i + 1
    create_stmt = create_stmt + ")"
  return create_stmt
def create_copy(tablename, csvfile):
  cstmt = "COPY " + tablename + " FROM '" + csvfile + "' csv delimiter ',' null '' header"
  return cstmt
locale.setlocale(locale.LC_ALL, 'en_US.UTF-8')
with open(csvfile) as file:
  reader = csv.reader(file)
  header = next(reader)
  first_line = next(reader)
sql_stmt = create_table(header, first_line)
rv = plpy.execute(sql_stmt)
copy_stmt = create_copy(tablename, csvfile)
rv = plpy.execute(copy_stmt)
return "Table successfully created and loaded."
$$;

SELECT create_load('stormdata', 'C:\\DataSets\\stormevents\\StormEvents_details-ftp_v1.0_d1950_c20210803.csv');
