WITH cal_stats AS (
  SELECT min(housing_median_age) as min,
  max(housing_median_age) as max
  FROM cal_housing
),
  histogram AS (
    SELECT width_bucket(housing_median_age, min, max, 19) as bucket,
    int4range(min(housing_median_age::INTEGER), max(housing_median_age::INTEGER), '[]') as range,
    count(*) AS freq
    FROM cal_housing, cal_stats
    GROUP BY bucket
    ORDER BY bucket
  )
  SELECT bucket, range, freq,
    repeat('=',
    (freq::float / max(freq) over() * 30)::INTEGER) AS bar
    FROM histogram;
