import psycopg2
from psycopg2 import Error
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import math
try:
  sqlstmt1 = input("Bitte Kern-SQL eingeben : ")
  print(sqlstmt1)
  sqlstmt2 = input("Bitte SQL für Spaltendefinition eingeben : ")
  print(sqlstmt2)
  conn = psycopg2.connect(dbname="hanser", user="postgres", password="postgres", host="localhost")
  conn.set_session(autocommit=False)                                     (1)
  cursor = conn.cursor()
  cursor.execute(sqlstmt2)                                               (2)
  row = cursor.fetchone()
  x_ax_desc = []
  y_ax_desc = []
  while row is not None:
    x_ax_desc.append(row[0])
    row = cursor.fetchone()
  cursor.callproc('pivot_cursor',['curname',sqlstmt1,sqlstmt2])
  rcurs = conn.cursor('curname')                                         (3)
  plist = []
  for record in rcurs:
    plist.append(record[1:])
    y_ax_desc.append(record[0])
  npArray = np.asarray(plist,dtype='float')                              (4)
  npArray = np.nan_to_num(npArray, copy=False, nan=0.0)
  fig, ax = plt.subplots()
  plt.imshow(npArray, cmap='tab20_r', interpolation='nearest')
  ax.set_xticks(np.arange(len(x_ax_desc)), labels=x_ax_desc)
  ax.set_yticks(np.arange(len(y_ax_desc)), labels=y_ax_desc)
  plt.setp(ax.get_xticklabels(), rotation= 90, ha="right", rotation_mode="anchor")
  plt.show()
except (Exception, Error) as error:
  print("Fehler: ", error)
finally:
  cursor.close()    
  conn.close()
