import psycopg2
import psycopg2.extras as extras
import pandas as pd
def insert_values(conn, df, table):
  tuples = [tuple(x) for x in df.to_numpy()]
  cols = ','.join(list(df.columns))
  query = "INSERT INTO %s(%s) VALUES %%s" % (table, cols)
  cursor = conn.cursor()
  try:
    extras.execute_values(cursor, query, tuples)
    conn.commit()
  except (Exception, psycopg2.DatabaseError) as error:
    print("Error: %s" % error)
    conn.rollback()
    cursor.close()
    return 1
  cursor.close()
conn = psycopg2.connect(database="hanser",user='postgres',password='postgres',host='localhost', port='5432')
sql = '''CREATE TABLE geo_daten(longitude numeric ,latitude numeric, housing_median_age int);'''
cursor = conn.cursor()
cursor.execute(sql)
data = pd.read_csv("c:\\temp\\california_housing.csv")
data = data[["longitude","latitude","housing_median_age"]]
print(data)
insert_values(conn, data, 'geo_daten')
