import psycopg2
from psycopg2 import Error
import matplotlib.pyplot as plt
import pandas as pd
import numpy as np
try:
  sqlstmt = "SELECT begin_lon,begin_lat,CAST(damage_property AS DECIMAL),event_type FROM stormdata WHERE state = 'FLORIDA' AND event_type IN ('Flash Flood','Flood','Tornado')"
  conn = psycopg2.connect(dbname="hanser", user="postgres", password="postgres", host="localhost")
  data = pd.read_sql_query(sqlstmt, conn)
  colors = {'Flash Flood':'red','Flood':'green','Tornado':'blue'}
  data.plot(kind="scatter", x="begin_lon", y="begin_lat",
    s=data['damage_property']/100000,
    c=data['event_type'].map(colors), cmap=plt.get_cmap("jet"),
    alpha=0.4, figsize=(10,7)
	)
  plt.legend()
  plt.show()
except (Exception, Error) as error:
  print("Fehler: ", error)
finally:
  conn.close()  
