import psycopg2
from psycopg2 import Error
import matplotlib.pyplot as plt
try:
	sqlstmt = "select ts_rank_cd(to_tsvector(bewertung), query) AS rank FROM imdb, to_tsquery('christmas') query WHERE query @@ to_tsvector(bewertung) ORDER BY rank desc"
	conn = psycopg2.connect(dbname="movdb", user="postgres", password="postgres", host="localhost")
	cursor = conn.cursor()
	cursor.execute(sqlstmt)
	rlist = []
	rows = cursor.fetchall()
	for row in rows:
		rlist.append(row[0])
	n, bins, patches=plt.hist(rlist,bins=20)
	plt.xlabel("Values")
	plt.ylabel("Frequency")
	plt.title("Histogram Rankings")
	plt.show()
except (Exception, Error) as error:
  print("Fehler: ", error)
finally:
  cursor.close()    
  conn.close()
