public static void get_lcrs(XStreamOut xsOut) {
  byte[] ping_pos = null;
  byte[] fetchlwm = null;
  String src_db = null;
  if (null == xsOut) {
    System.out.println("xstreamOut ist nicht aktiv.");
    System.exit(0);
  }
  try {
    while(true) {
      LCR alcr = xsOut.receiveLCR(XStreamOut.DEFAULT_MODE);         (1)
      System.out.println(alcr);                                     (2)
      fetchlwm = xsOut.getFetchLowWatermark();                      (3)
      if (null != alcr)
        src_db = alcr.getSourceDatabaseName();
      if (xsOut.getBatchStatus() == XStreamOut.EXECUTING) {         (4)
        assert alcr != null;
        if (alcr instanceof RowLCR) {
          if (((RowLCR)alcr).hasChunkData()) {                      (5)
            ChunkColumnValue chunk = null;
            do {
              chunk = xsOut.receiveChunk(XStreamOut.DEFAULT_MODE);
            } while (!chunk.isEndOfRow());
          }
        }
        processedLowPosition = alcr.getPosition();                  (6)
        ping_pos = processedLowPosition; 
      } else  {                                                    
        assert alcr == null;
        if (null != processedLowPosition)
          xsOut.setProcessedLowWatermark(processedLowPosition,
          XStreamOut.DEFAULT_MODE);
        }
      }
    }
  } catch(Exception e) {
    System.out.println("exception when processing LCRs");
    System.out.println(e.getMessage());
    e.printStackTrace();
  }
}
