import oracle.streams.*;
import oracle.jdbc.internal.OracleConnection;
import oracle.jdbc.*;
import oracle.sql.*;
import java.sql.*;
import java.util.*;
public class xstream_pg {
  public static String out_url = null;
  public static Connection out_conn = null;
  public static XStreamOut xsOut = null;
  public static String xsoutName = "xout";
  public static byte[] lastPosition = null;
  public static byte[] processedLowPosition = null;
  public static Connection createConnection(String url, String username, 
String passwd) {
    try {
      DriverManager.registerDriver(new oracle.jdbc.OracleDriver());
      return DriverManager.getConnection(url, username, passwd);
    } catch(Exception e) {
      System.out.println("Datenbankverbindung konnte nicht hergestellt 
werden: " +url);
      e.printStackTrace();
      return null;
    }
  }
  public static void printHex(byte[] b) {
    for (int i = 0; i < b.length; ++i) {
      System.out.print(Integer.toHexString((b[i]&0xFF) | 
0x100).substring(1,3));
    }
    System.out.println("");
  }
 
  public static XStreamOut attachOutbound(Connection out_conn) {
    XStreamOut xsOut = null;
    try {
      xsOut = XStreamOut.attach((OracleConnection)out_conn, xsoutName, 
lastPosition, XStreamOut.DEFAULT_MODE);
      System.out.println("Mit Outbound Server verbunden: "+xsoutName);
      System.out.print("Letzte Position ist: ");
      if (lastPosition != null) {
        printHex(lastPosition);
      }
      else {
        System.out.println("NULL");
      }
      return xsOut;
    } catch(Exception e) {
      System.out.println("Verbindung zu Outbound Server nicht möglich: "+xsoutName);
      System.out.println(e.getMessage());
      e.printStackTrace();
      return null;
    }
  }
  private static boolean samePos(byte[] pos1, byte[] pos2) {
    int cmp_len;
    boolean result;
    if (pos1.length != pos2.length) {
      return false;
    }
    for (int i = 0; i<pos1.length; i++) {
      if (pos1[i] != pos2[i])
        return false;
    }
    return true;
  }
  public static void get_lcrs(XStreamOut xsOut) {
    byte[] ping_pos = null;
    byte[] fetchlwm = null;
    String src_db = null;
    if (null == xsOut) {
      System.out.println("xstreamOut is null");
      System.exit(0);
    }
    try {
      while(true) {
        LCR alcr = xsOut.receiveLCR(XStreamOut.DEFAULT_MODE);
        System.out.println(alcr);
        fetchlwm = xsOut.getFetchLowWatermark();
        if (null != alcr)
          src_db = alcr.getSourceDatabaseName();
        if (xsOut.getBatchStatus() == XStreamOut.EXECUTING) {
          assert alcr != null;
          if (alcr instanceof RowLCR) {
            if (((RowLCR)alcr).hasChunkData()) {
              ChunkColumnValue chunk = null;
              do {
                chunk = xsOut.receiveChunk(XStreamOut.DEFAULT_MODE);
                System.out.println(chunk.toString());
              } while (!chunk.isEndOfRow());
            }
          }
          processedLowPosition = alcr.getPosition();
          ping_pos = processedLowPosition; 
        } else  {
          assert alcr == null;
          if (null != processedLowPosition)
            xsOut.setProcessedLowWatermark(processedLowPosition, XStreamOut.DEFAULT_MODE);
        }
      }
    } catch(Exception e) {
      System.out.println("Ausnahmebedingung bei LCR-Verarbeitung");
      System.out.println(e.getMessage());
      e.printStackTrace();
    }
  }
  public static void detachOutbound(XStreamOut xsOut) {
    try {
      xsOut.detach(XStreamOut.DEFAULT_MODE);
    } catch(Exception e) {
      System.out.println("Abmeldung vom Outbound Server ist nicht möglich: "+xsoutName);
      System.out.println(e.getMessage());
      e.printStackTrace();
    }
  }
  public static void main(String args[]) {
    out_url = "jdbc:oracle:oci:@"+"localhost"+":"+"1521"+":"+"OEM";
    System.out.println(out_url);
    out_conn = createConnection(out_url, "sys as sysdba", "manager");
    xsOut = attachOutbound(out_conn);
    get_lcrs(xsOut);
    detachOutbound(xsOut);
  }
}
